package org.ghisler.tcpacker;

import android.app.NotificationManager;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.content.res.Configuration;
import android.os.Build;
import android.os.Handler;
import android.os.IBinder;

import org.ghisler.a7zip.AndroidMFunctions;

public class PluginService extends Service {
	NotificationManager mNM;
	PackerPluginFunctions packerPluginFunctions = null;
	public static Handler mHandler = null;
	public boolean notificationShown=false;
	static PluginService thisService;

	public static PluginService get() {
		return thisService;
	}

	@Override
	public IBinder onBind(Intent intent) {
		thisService = this;
		String s1 = IPackerPluginFunctions.class.getName();
		String s2 = intent.getAction();
		int i1 = s1.lastIndexOf('.');
		int i2 = s2.lastIndexOf('.');
		// do NOT check full name here, it will differ, otherwise there could be only one plugin!
		if (i1 > 0 && i2 > 0 && s1.substring(i1).equals(s2.substring(i2))) {
			if (packerPluginFunctions == null)
				packerPluginFunctions = new PackerPluginFunctions(this);
			return packerPluginFunctions;
		}
		return null;
	}

	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		// We want this service to continue running until it is explicitly
		// stopped, so return sticky.
		thisService = this;
		return START_STICKY;
	}

	@Override
	public void onCreate() {

		thisService = this;
		mNM = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
		mHandler = new Handler(getMainLooper());
	}

	@Override
	public void onDestroy() {
		// Tell the user we stopped.
		//Toast.makeText(this, R.string.remote_service_stopped, Toast.LENGTH_SHORT).show();

		// Unregister all callbacks.
		// mCallbacks.kill();

	}

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
	}

	public static int requestPermissionResults=0;
	public static boolean permissionBusy=false;

	public static boolean requestWriteRightsAndWait(final Context context) {
		requestPermissionResults=0;
		try {  // catch crash if Android M functions missing
			if (Build.VERSION.SDK_INT >= 23)
				if (AndroidMFunctions.hasStorageReadWriteRights(context)) {
					return true;
				} else {
					if (permissionBusy)
						return false;
					PluginService.mHandler.post(new Runnable() {
						@Override
						public void run() {
							try {
								Intent intent=new Intent(context,PermissionRequestActivity.class);
								intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
								permissionBusy=true;
								context.startActivity(intent);
							} catch (Throwable e) {
								requestPermissionResults=-1;
							}
						}
					});
					while (requestPermissionResults==0)
						Thread.sleep(100);
					return requestPermissionResults==1;
				}
		} catch (Throwable e) {}
		return true;
	}


}
